/* Problem URL: https://codeforces.com/gym/104020/problem/J */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll w, h;
    cin >> w >> h;

    vi columns(w);
    rep(i, w) {
        columns[i] = i;
    }

    mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
    shuffle(all(columns), rng);

    ll ansx = 1;
    ll ansy = 0;
    repv(i, columns) {
        if (ansy == h) {
            break;
        }
        cout << "? " << i + 1 << ' ' << ansy + 1 << endl;

        string a;
        cin >> a;

        if (a == "sky") {
            continue;
        }

        ll low = ansy + 1;
        ll high = h;
        while (low <= high) {
            ll mid = (high - low) / 2 + low;

            cout << "? " << i + 1 << ' ' << mid << endl;

            cin >> a;

            if (a == "building") {
                ansy = mid;
                ansx = i + 1;
                low = mid + 1;
                continue;
            }

            high = mid - 1;
        }
    }

    cout << "! " << ansx << ' ' << ansy << endl;
}
